package fxHiihtorekisteri;

import java.io.PrintStream;
import java.util.ArrayList;

import Tietorakenteet.Hiihto;
import Tietorakenteet.Jasen;
import Tietorakenteet.Rekisteri;
import Tietorakenteet.SailoException;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.StringGrid;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.MenuItem;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;


/**
 * @author JPo ja MHo
 * @version 13.1.2020
 * 
 */
public class HiihtorekisteriGUIController {

    @FXML
    private TextField Hakukentta;
    
    @FXML
    private Button nappiLisaaHiihto;

    @FXML
    private Button nappiMuokkaa;

    @FXML
    private Button nappiTulosta;
    
    @FXML
    private MenuItem ylanappiTallenna;

    @FXML
    private MenuItem ylanappiTulosta;

    @FXML
    private MenuItem ylanappiLisaaHiihtaja;

    @FXML
    private MenuItem ylanappiPoistaHiihtaja;

    @FXML
    private MenuItem ylanappiLopeta;
    
    @FXML
    private MenuItem ylanappiKayttoOhje;

    @FXML
    private MenuItem ylanappiTietoja;
    
    @FXML
    private ListChooser<Jasen> chooserJasenet;
    
    //@FXML
    //private TextArea areaTiedot;
    
    @FXML
    private TextField kenttaNimi;

    @FXML
    private TextField kenttaSAika;

    @FXML
    private TextField kenttaPKunta;

    @FXML
    private TextField kenttaPuh;

    @FXML
    private TextField kenttaEmail;

    @FXML
    private TextField kenttaLVuosi;

    @FXML
    private TextField kenttaKm;
    
    @FXML
    private StringGrid<?> gridHiihdot;
 
    private Rekisteri rekisteri;
    private Jasen jasenKohdalla;

    
    /**
     * @param rekisteri jota käytetään
     */
    public void setRekisteri(Rekisteri rekisteri) {
        this.rekisteri = rekisteri;
        alusta();
        naytaJasen();
    }

    
    /**
     * Näyttää listasta valitun jäsenen tiedot, tilapäisesti yhteen isoon edit-kenttään
     */
    protected void naytaJasen() {
        jasenKohdalla = chooserJasenet.getSelectedObject();

        if (jasenKohdalla == null) return;
        
        TextField[] kentat = new TextField[] {kenttaNimi, kenttaSAika, kenttaPKunta, kenttaPuh, kenttaEmail, kenttaLVuosi};
        String[] tiedot = jasenKohdalla.getTiedot();
        for (int i = 0; i < tiedot.length; i++) {
            kentat[i].setText(tiedot[i]);
        }
    }
    
    
    /**
     * Näyttää listasta valitun jäsenen hiihdot
     */
    protected void naytaHiihdot() {
        jasenKohdalla = chooserJasenet.getSelectedObject();
        ArrayList<Hiihto> jasenenHiihdot = rekisteri.getJasenenHiihdot(jasenKohdalla.getID());
        gridHiihdot.clear();
        for (int i = 0; i < jasenenHiihdot.size(); i++) {
                String[] rivi = jasenenHiihdot.get(i).getTiedot();
                gridHiihdot.add(rivi);
        }
    }

    
    @FXML
    void handleHaku() {
        //
    }
    
    @FXML
    void handleLisaaHiihto() {
        //ModalController.showModal(HiihtorekisteriGUIController.class.getResource("LisaaHiihto.fxml"), "Hiihto", null, "");
        jasenKohdalla = chooserJasenet.getSelectedObject();
        int id = jasenKohdalla.getID();
        try {
            rekisteri.lisaaHiihto(new Hiihto(id));
        } catch (SailoException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        hae(jasenKohdalla.getID());
    }
    
    @FXML
    void handleMuokkaa() {
        ModalController.showModal(HiihtorekisteriGUIController.class.getResource("Muokkaa.fxml"), "Hiihtaja", null, "");
    }

    @FXML
    void handleTulosta() {
        ModalController.showModal(HiihtorekisteriGUIController.class.getResource("Tulosta.fxml"), "Tulosta", null, "");
    }
    
    @FXML
    void handleLisaaHiihtaja() {
        Jasen uusi = new Jasen();
        try {
            rekisteri.lisaa(uusi);
        } catch (SailoException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        //ModalController.showModal(HiihtorekisteriGUIController.class.getResource("LisaaHiihtaja.fxml"), "Hiihtaja", null, "");
        hae(uusi.getID());
    }
    
    @FXML
    void handlePoistaHiihtaja() {
        Dialogs.showMessageDialog("Poisto ei vielä toimi");
    }

    @FXML
    void handleTallenna() {
        Dialogs.showMessageDialog("Tallennus ei toimi vielä");
    }
    
    @FXML
    void handleLopeta() {
        Dialogs.showMessageDialog("Tallentaa tiedot ja lopettaa ohjelman. Tallennus ei toimi vielä.");
    }
    
    @FXML
    void handleKayttoOhje() {
        ModalController.showModal(HiihtorekisteriGUIController.class.getResource("Ohje.fxml"), "Ohje", null, "");
    }
    
    @FXML
    void handleTietoja() {
        ModalController.showModal(HiihtorekisteriGUIController.class.getResource("Tietoja.fxml"), "Tietoja", null, "");
    }
    
    
    /**
     * Hakee jäsenten tiedot listaan
     * @param jnro jäsenen numero, joka aktivoidaan haun jälkeen
     */
    protected void hae(int jnro) {
        chooserJasenet.clear();
        
        int index = 0;
        for (int i = 0; i < rekisteri.getLkm(); i++) {
            Jasen jasen = rekisteri.annaJasen(i);
            if (jasen.getID() == jnro) index = i;
            chooserJasenet.add(jasen.getID() + " " + jasen.getNimi(), jasen);
        }
        chooserJasenet.setSelectedIndex(index); // tästä tulee muutosviesti joka näyttää jäsenen
    }

    
    /**
     * Alustaa listan jäsenistä
     */
    protected void alusta() {
        chooserJasenet.clear();
        chooserJasenet.addSelectionListener(e -> naytaJasen());
        chooserJasenet.addSelectionListener(e -> naytaHiihdot());
    }
}